"""
Basic python : numbers, operations, writing numbers, int, float
Author :  Alexandre CAMERON
Email  :  alexandre.cameron@ens.fr
Input  :  None
Command:  python part2.py
"""

import matplotlib.pyplot as plt
import matplotlib as mpl
import numpy as np
import pylab as pb
import shlex as sx
import shutil as sl
import subprocess as sp
import sys
import os
import math




###### 1) Simple operations on integers
### Recording file
odir = './out2/'
if not os.path.exists(odir):
    os.mkdir(odir)
file = open( odir+'part2-1.txt' , 'w+' )
### Assigning value
ABa = 3
ABb = 7
### Sum
ABc = ABa+ABb
### Multiplication
ABd = ABa*ABb
### Quotient 
ABe = ABa/ABb
### Remainder
ABf = ABa%ABb
### Quotient 
ABg = ABb/ABa
### Remainder
ABh = ABb%ABa
### Power
ABi = ABa**ABb
### Power
ABj = ABb**ABa
# NB: it's better to have 3 letter variables, to avoid conflicts

file.write("a="+str(ABa)+" , b="+str(ABb)+"\n" )
file.write("c=a+b="+str(ABc)+" , d=a*b="+str(ABd)+"\n" )
file.write("e=a/b="+str(ABe)+" , f=a%b="+str(ABf)+"\n" )
file.write("Check e*b+f="+str(ABe)+"*"+str(ABb)+"*"+str(ABf)+"="+str(ABe*ABb+ABf)+"\n")
file.write( "\n")
file.write("g=b/a="+str(ABg)+" , h=b%a="+str(ABh)+"\n" )
file.write("Check g*a+h="+str(ABg)+"*"+str(ABa)+"*"+str(ABh)+"="+str(ABg*ABa+ABh)+"\n")
file.write( "\n")
file.write("i=a**b="+str(ABi)+" , j=b**a="+str(ABj)+"\n" )

file.close()





###### 2) Simple operations on float
### Recording file
odir = './out2/'
if not os.path.exists(odir):
    os.mkdir(odir)
file = open( odir+'part2-2.txt' , 'w+' )
### Assigning float value (the decimal . is enough to make a float) 
CDa = 3.
CDb = 7.
### Sum
CDc = CDa+CDb
### Multiplication
CDd = CDa*CDb
### Quotient 
CDe = CDa/CDb
### Remainder
CDf = CDa%CDb
### Quotient 
CDg = CDb/CDa
### Remainder
CDh = CDb%CDa
### Power
CDi = CDa/CDb
### Power
CDj = CDb/CDa
# NB: it's better to have 3 letter variables, to avoid conflicts

file.write("a="+str(CDa)+" , b="+str(CDb)+"\n" )
file.write("c=a+b="+str(CDc)+" , d=a*b="+str(CDd)+"\n" )
file.write("e=a/b="+str(CDe)+" , f=a%b="+str(CDf)+"\n" )
file.write("Check: e*b+f="+str(CDe)+"*"+str(CDb)+"+"+str(CDf)+"="+str(CDe*CDb+CDf)+"\n")
file.write("Check: e*b="+str(CDe)+"*"+str(CDb)+"="+str(CDe*CDb)+"\n")
file.write( "\n")
file.write("g=b/a="+str(CDg)+" , h=b%a="+str(CDh)+"\n" )
file.write("Check: g*a+h="+str(CDg)+"*"+str(CDa)+"+"+str(CDh)+"="+str(CDg*CDa+CDh)+"\n")
file.write("Check: g*a="+str(CDg)+"*"+str(CDa)+"="+str(CDg*CDa)+"\n")
file.write( "\n")
file.write("i=a**b="+str(CDi)+" , j=b**a="+str(CDj)+"\n" )

file.close()





###### 3) Going from float to integer
### Recording file
odir = './out2/'
if not os.path.exists(odir):
    os.mkdir(odir)
file = open( odir+'part2-3.txt' , 'w+' )
### Assigning value
EFa = 3.54
EFb = int(EFa)
EFc = float(EFb)
EFd = int(-EFa)
EFe = float(-EFb)

file.write( "a="+str(EFa)+"\n")
file.write( "int(a)="+str(EFb)+"\n")
file.write( "float(int(a))="+str(EFa)+"\n")
file.write( "int(-a)="+str(EFd)+"\n")
file.write( "float(int(-a)="+str(EFe)+"\n")

file.write( "\n")

### Lower and upper integer (floor, ceil)
### (using numpy package as np)
EFf = np.floor(EFa)
EFg = np.ceil(EFa)
EFh = np.floor(-EFa)
EFi = np.ceil(-EFa)

file.write( "f=floor(a)="+str(EFf)+"\n")
file.write( "g=ceil(a)="+str(EFg)+"\n")
file.write( "h=floor(-a)="+str(EFh)+"\n")
file.write( "i=floor(-a)"+str(EFi)+"\n")

file.close()




###### 4) Print float with a limited number of digits
### Recording file
odir = './out2/'
if not os.path.exists(odir):
    os.mkdir(odir)
file = open( odir+'part2-4.txt' , 'w+' )
### Assigning value

GHa = 1./3.
GHb = GHa*1e10

file.write( "Default output:\n")
file.write( "a="+str(GHa)+"\n")
file.write( "b="+str(GHb)+"\n")
file.write( "\n")
file.write( "Selecting the number of digit:\n")
file.write( "f version (full):\n")
file.write( "a=%5.3f\n" %GHa)
file.write( "b=%5.3f\n" %GHb)
file.write( "g version (shortest):\n")
file.write( "a=%5.3g\n" %GHa)
file.write( "b=%5.3g\n" %GHb)
file.write( "e version (scientific):\n")
file.write( "a=%5.3e\n" %GHa)
file.write( "b=%5.3e\n" %GHb)

file.close()




###### Exercise
# Create a file : 'part2_ex.txt' in directory: './out2/'
# Write your age: in years then in months then in days 
# then in hours then in seconds
# Write the output in scientific notation (e version)
# Assuming that you sleep 1/3 of your life output the 
# the number of hours you have been avake
