"""
Basic python : plots
Author :  Alexandre CAMERON
Email  :  alexandre.cameron@ens.fr
Input  :  None
Command:  python part4.py
"""

import matplotlib.pyplot as plt
import matplotlib as mpl
import numpy as np
import pylab as pb
import shlex as sx
import shutil as sl
import subprocess as sp
import sys
import os
import math




###### 1) Simple plot 
### Recording directory
odir = './out4/'
if not os.path.exists(odir):
    os.mkdir(odir)
file = open( odir+'part4-1.txt' , 'w+' )

Xval = range(10)
Yval = range(10,50,4)

### Making a figure
plt.figure()
### Making a plot
plt.plot(Xval,Yval)
### Saving plot
plt.savefig(odir+'fig1.png')
plt.savefig(odir+'fig1.pdf')
plt.savefig(odir+'fig1.svg')
plt.savefig(odir+'fig1.jpg')
plt.savefig(odir+'fig1.eps')
### Drawing plot
plt.draw()
### Closing plot
plt.close()

file.write("Plotting Y=4*X+10\n")
file.write("Output saved in png, pdf, svg, jpg, eps\n")
file.write("\n")

file.write("plt.figure()\n")
file.write("plt.plot(Xval,Yval)\n")
file.write("plt.savefig('fig1.png')\n")
file.write("plt.draw()\n")
file.write("plt.close()\n")

file.close()




###### 1) Plot with more options  
### Recording directory
odir = './out4/'
if not os.path.exists(odir):
    os.mkdir(odir)

Xval = np.arange(10)
Yval = np.exp(Xval)

### Making a figure
plt.figure()
### Making a plot with options
plt.plot(Xval,Yval, lw=3, ls=':', c='g', marker='o', mfc='b', mec='r', mew=3, ms=15, label='data')
plt.savefig(odir+'fig2-1.png')
### Ading data ledgend
plt.legend(loc=2)
plt.savefig(odir+'fig2-2.png')
### Adding label on the axis
plt.xlabel(r'$Axis_{x}$') 
plt.ylabel('$y=Exp(x)$') 
# r'$ $' give LateX font and output
plt.savefig(odir+'fig2-3.png')
### Adding tittle
plt.title('Graphe of y=Exp(x)')
plt.savefig(odir+'fig2-4.png')
### Making a saving plot
plt.annotate( r'$Box$', xy = (2, 1e3), 
              xytext = (10, 10),textcoords = 'offset points', ha = 'left', va = 'bottom',
              bbox = dict(boxstyle = 'round,pad=0.5', fc = 'b', alpha = .7))
plt.annotate( r'$ArrowedBox$', xy = (7.7, 3.3e3), 
              xytext = (-100, 50),
              textcoords = 'offset points', ha = 'left', va = 'bottom',
              bbox = dict(boxstyle = 'round,pad=0.5', fc = 'y', alpha = .7),
              arrowprops = dict(facecolor='k', arrowstyle = '-|>', 
                                connectionstyle = 'arc3,rad=0'))
plt.savefig(odir+'fig2-5.png')
### Drawing plot
plt.draw()
### Closing plot
plt.close()


###### Exercise
# Make a plot of a cosine on 4 periods
# Put a black dotted line and red 'x' marker
# Place X and Y axis
# Put a title
# Save plot of 'cos.pdf'
