"""
Basic python : function and class
Author :  Alexandre CAMERON
Email  :  alexandre.cameron@ens.fr
Input  :  None
Command:  python part6.py
"""

import matplotlib.pyplot as plt
import matplotlib as mpl
import numpy as np
import pylab as pb
import shlex as sx
import shutil as sl
import subprocess as sp
import sys
import os
import math




###### 1) Making a simple function
### Recording directory
odir = './out6/'
if not os.path.exists(odir):
    os.mkdir(odir)
file = open( odir+'part6-1.txt' , 'w+' )

### Function start have are written
# def <name_function> ( <arguments> ) :
# <indent> procedure
# <indent> return output 
def polynom ( in_value ) :
    """
    Output assicated polynomial value
    Input : in_value
    Ouput : out_value
    """
    out_value = in_value**2+2*in_value+1
    return out_value


for iter in range(4) :
    file.write(str(iter)+ "**2+2*"+str(iter)+
               "+1="+str(polynom(iter))+"\n")

file.close()





###### 2) Making a simple class
### Recording directory
odir = './out6/'
if not os.path.exists(odir):
    os.mkdir(odir)

### Function start have are written
# def <name_function> ( <arguments> ) :
# <indent> procedure
# <indent> return output 
class poly ( object ) :
    """
    Class to make polynom
    Input : in_value
    Ouput : out_value
    """
    def poly_func (self, in_value) :
        aux_value=0
        self.dlen = len(self.data)
        for iter in range(self.dlen) :
            aux_value = aux_value + self.data[iter]*np.power(in_value,iter)
        return aux_value
    
    def ex_test (self ) :
        self.Xval = range(10)
        self.Yval = self.poly_func(self.Xval)
        return

    def plot (self ) :
        plt.figure()
        plt.plot(self.Xval, self.Yval, 'rx' )
        plt.savefig(self.odir+'fig6.pdf')
        plt.close()
        
    def __init__ (self, data) :
        """
        Input data
        """
        self.data=data
        self.odir = './out6/'
        if not os.path.exists(self.odir):
            os.mkdir(self.odir)
        self.ex_test()
        self.plot()
        return

poly( [-5,10,-1] )




###### Exercise
# Make a class to plot A*exp(k*x) with parameter (A, K)
# Plot the function for A in [-1,0,1,,2,3] and k in [-1,1]
